<template>
    <f7-page 
        name="chatsender" 
        @page:beforein="onPageBeforeIn"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Chat Pembeli">
            <f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">Chat</f7-nav-title>
		</f7-navbar>
        <f7-list media-list no-hairlines v-if="!chatLoading && chats.length > 0">
            <f7-list-item
                v-for="(item, index) in chats"
                :key="index"
                :link="`/chat/${item.id}/messages/`"
                :after="item.last_message != null ? hoursAgo(item.created) : ''"
                :title="item.sender.profile.store_name != null ? item.sender.profile.store_name : item.sender.profile.fullname"
                :text="item.last_message != null ? truncate(stripHTML(item.last_message.message)) : 'Ketik pesan...'"
            >
                <img v-if="item.sender.profile.media != null" :src="item.sender.profile.media.url.small" width="48" height="48" class="img-circle" slot="media"/>
                <div v-else :data-initial-medium="item.sender.profile.initial" slot="media"></div>
            </f7-list-item>
            
        </f7-list>
        <f7-block v-else-if="!chatLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="speaker_notes_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
        <f7-list media-list no-hairlines v-if="chatLoading">
            <f7-list-item
                v-for="n in 4"
                :key="n"
                class="skeleton-text skeleton-effect-blink"
                title="Full Name"
                subtitle="Position"
                after="31 Juli 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit. Aliquam vestibulum vitae lorem ac iaculis. Praesent nec pharetra massa, at blandit lectus. Sed tincidunt, lectus eu convallis elementum, nibh nisi aliquet urna, nec imperdiet felis sapien at enim."
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>     
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { parseError, hoursAgo, dateFormat, truncate, stripHTML } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'ChatSender',
	data(){
		return{
            chatLoading: true,
            allowInfinite: false,
            showPreloader: true,
        };
	},
	computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('chat', [
            'chats',
            'pagination',
        ])
    },
    methods: {
        hoursAgo,
        dateFormat,
        truncate,
        stripHTML,
        convertAmpersand(text){
            return text.replace(/&amp;/g, '&');
        },
        getChats(page, loadmore){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('chat/getChats', {
                chattype: 'recipient',
                page: page,
                perpage: 25,
                loadmore: loadmore,
            }).then((response)=> {
                setTimeout(()=>{
                    self.chatLoading = false;
                    self.showPreloader = self.pagination.has_next;
                }, 100);
            });
        },
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            self.getChats(1, false);
        },
        onPageRefresh(e, done){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('chat/resetChat').then(()=>{
                self.chatLoading = true;
                self.getChats(1, false);
                done();
            });
        },
        loadMore(){
            const self = this;
            const app = self.$f7;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.pagination.has_next){
                    self.getChats(self.pagination.page + 1, true);
                    self.allowInfinite = true;
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        }
    }
}
</script>
